#######################################################################
# Welcome to Premessa - CYTO 2022
######################################################################

## This will force the creation of a backup input and output CSV file for additional debugging
debug_input_output <- FALSE
## For debugging to see what FlowJo is passing to the script.
##
## cat("INPUT-IT                = INPUT_IT \n")
## cat("INPUT-MD          		= INPUT_MAD \n")
## cat("FJ-PAR-Cytof            = FJ_PAR_Cytof \n")
## cat("FJ-PAR-QCSAMPLES        = FJ_PAR_QCSAMPLES \n")
## cat("OUT-PATH            	= OUT_PATH \n")
## cat("FJ-DATA-FILE-PATH"       = FJ_DATA_FILE_PATH \n")
## cat("FJ-PARAMS-LIST          = FJ_PARAMS_LIST \n")



## INSTALL REQUIRED PACKAGES ##
#######################
# Install function for packages

loadPackages<-function(...){
libs<-unlist(list(...))
	req<-unlist(lapply(libs,require,character.only=TRUE))
	need<-libs[req==FALSE]
	if(length(need)>0){
		tryCatch({
			install.packages(pkgs=need, repos="https://cloud.r-project.org")
		}, error = function(e){
		tryCatch({
			install.packages(pkgs=need, repos="https://cloud.r-project.org", type = 'binary')
		}, error = function(e){
			dir.create(path = Sys.getenv("R_LIBS_USER"), showWarnings = FALSE, recursive = TRUE)
			install.packages(pkgs=need, lib = Sys.getenv("R_LIBS_USER"), repos="https://cloud.r-project.org", type = 'binary')
		})
	})
	lapply(need,require,character.only=TRUE)
	}
}


loadBioc<-function(...){
	libs<-unlist(list(...))
	req<-unlist(lapply(libs,require,character.only=TRUE))
	need<-libs[req==FALSE]
	if(length(need)>0){
		tryCatch({
			BiocManager::install(need)
		}, error = function(e){
			tryCatch({
				BiocManager::install(need, type = 'binary')
			}, error = function(e){
				BiocManager::install(need, lib = Sys.getenv("R_LIBS_USER"), type = 'binary')
			})
		})
	lapply(need,require,character.only=TRUE)
	}
}

# the Real Deal (aka required packages) #
loadPackages(c('devtools', 'shiny', 'BiocManager'))
loadBioc('flowCore')
install_github("ParkerICI/premessa")

######################
######################
## Last tested with R 4.2.0 (2022-06-05)
## Check what the user has and compare to what we know works
sessionInfo()

sampleFolder <<- "FJ_DATA_FILE_PATH"

outApp <- paste0("FJ_OUTS_FOLDER","/app.R")
runApp(outApp, launch.browser=TRUE)

#library(premessa)





